﻿:namespace files
    
    (⎕IO ⎕ML)←1 1

    ∇ Chars←ReadFile name;nid;signature;nums;sz
     ⍝ Read ANSI or Unicode character file (Windows)
      sz←⎕NSIZE nid←name ⎕NTIE 0
      signature←⎕NREAD nid 83 3 0
      :If signature≡¯17 ¯69 ¯65 ⍝ UTF-8?
          nums←⎕NREAD nid 83 sz
          Chars←'UTF-8'⎕UCS 256|nums ⍝ Signed ints
      :ElseIf (2↑signature)≡¯1 ¯2 ⍝ Unicode (UTF-16)
          Chars←'UTF-16'⎕UCS(2*16)|163 ⎕DR ⎕NREAD nid 83 sz 2
      :Else ⍝ ANSI
          Chars←⎕UCS ⎕NREAD nid 83 sz 0
      :EndIf
      ⎕NUNTIE nid
    ∇

    ∇ {format}WriteFile(name chars);nid;signature;nums;typ
      ⍝ Write ANSI or Unicode character file (Windows)
      ⍝ format = ANSI, UTF-8 or UTF-16
      ⎕SIGNAL(×10|typ←⎕DR chars)/11 ⍝ won't work in Classic APL
      :If 0=⎕NC'format'
          format←(1+80≠typ)⊃'ANSI' 'UTF-16'
      :EndIf
      ⎕SIGNAL(~(⊂format)∊'ANSI' 'UTF-8' 'UTF-16')/11
      :Trap 22
          nid←name ⎕NCREATE 0
      :Else
          name ⎕NERASE name ⎕NTIE 0
          nid←name ⎕NCREATE 0
      :EndTrap
     
      :Select format
      :Case 'ANSI'
          chars ⎕NAPPEND nid 80
      :Case 'UTF-8'
          ¯17 ¯69 ¯65 ⎕NAPPEND nid 83
          nums←⎕UCS'UTF-8'⎕UCS chars
          nums ⎕NAPPEND nid 80
      :Else
          ¯1 ¯2 ⎕NAPPEND nid 83
          {}⎕DR nums←{⍵-(2*16)×⍵≥2*15}'UTF-16'⎕UCS chars ⍝ make sure it is type 163
⍝ We write as a stream of bytes to avoid little endian problems
          (83 ⎕DR nums)⎕NAPPEND nid 83
      :EndSelect
      ⎕NUNTIE nid
    ∇
:endnamespace