﻿:class Zip
    (⎕IO ⎕ML)←1

    ∇ Using
      ⎕USING←'System.IO.Compression,System.IO.Compression.dll'
      ⎕USING,←⊂',System.IO.Compression.FileSystem.dll'
    ∇

    ∇ r←zipfile Open mode
      Using
      mode←ZipArchiveMode.(Update Read)⊃⍨'UR'⍳⊃mode
      r←ZipFile.Open(zipfile mode)
    ∇

    ∇ source Create zipfile;⎕USING;z;en;em
      :Access public shared
    ⍝ Zip a directory
      en←0 ⋄ em←''
      :Trap 0
          Using
          ZipFile.CreateFromDirectory source zipfile
      :Else
          (en em)←⎕DMX.(EN EM) ⋄ :If em≡'EXCEPTION' ⋄ em←{⍵/⍨∧\~⍵∊⎕UCS 13 10}⍕⎕EXCEPTION ⋄ :EndIf
      :EndTrap
      :Trap 0
          z.Dispose
      :EndTrap
      :If 0≠en ⋄ em ⎕SIGNAL en ⋄ :EndIf
    ∇

    ∇ zipfile UnZip destination;z;⎕USING;en;em
      :Access public shared
      en←0 ⋄ em←''
      :Trap 0
          Using
          ZipFile.ExtractToDirectory zipfile destination
      :Else
          (en em)←⎕DMX.(EN EM) ⋄ :If em≡'EXCEPTION' ⋄ em←{⍵/⍨∧\~⍵∊⎕UCS 13 10}⍕⎕EXCEPTION ⋄ :EndIf
      :EndTrap
      :Trap 0
          z.Dispose
      :EndTrap
      :If 0≠en ⋄ em ⎕SIGNAL en ⋄ :EndIf
    ∇

    ∇ r←Entries zipfile;z;⎕USING;en;em
      :Access public shared
      en←11 ⋄ em←'No entries'
      :Trap 0
          z←zipfile Open'R'
          r←0 3⍴'' '' 0
          :If 0<z.Entries.Count
              r←↑(⌷z.Entries).(FullName LastWriteTime Length)
              en←0
          :EndIf
      :Else
          (en em)←⎕DMX.(EN EM) ⋄ :If em≡'EXCEPTION' ⋄ em←{⍵/⍨∧\~⍵∊⎕UCS 13 10}⍕⎕EXCEPTION ⋄ :EndIf
      :EndTrap
      :Trap 0
          z.Dispose
      :EndTrap
      :If 0≠en ⋄ em ⎕SIGNAL en ⋄ :EndIf
    ∇

    ∇ zipfile ExtractEntry args;z;entry;t;⎕USING;em;en;args;overwrite;entryname;destination
      :Access public shared
      args←{2>|≡⍵:,⊂⍵ ⋄ ⍵}args
      en←3 ⋄ 'Entry not found'
      :Trap 0
          z←zipfile Open'R'
          :For entry :In z.Entries
              :If entry.FullName≡entryname
                  ZipFileExtensions.ExtractToFile(entry((destination,(((0∊⍴destination)∨(¯1↑destination)∊'\/'))/entryname))overwrite)
                  en←0
                  :Leave
              :EndIf
          :EndFor
      :Else
          (en em)←⎕DMX.(EN EM) ⋄ :If em≡'EXCEPTION' ⋄ em←{⍵/⍨∧\~⍵∊⎕UCS 13 10}⍕⎕EXCEPTION ⋄ :EndIf
      :EndTrap
      :Trap 0
          z.Dispose
      :EndTrap
      :If 0≠en ⋄ em ⎕SIGNAL en ⋄ :EndIf
    ∇

    ∇ zipfile DeleteEntry entryname;z;entry;⎕USING;en;em
      :Access public shared
      en←3 ⋄ em←'Entry not found'
      :Trap 0
          z←zipfile Open'U'
          :For entry :In z.Entries
              :If entry.FullName≡entryname
                  entry.Delete
                  en←0
                  :Leave
              :EndIf
          :EndFor
      :Else
          (en em)←⎕DMX.(EN EM) ⋄ :If em≡'EXCEPTION' ⋄ em←{⍵/⍨∧\~⍵∊⎕UCS 13 10}⍕⎕EXCEPTION ⋄ :EndIf
      :EndTrap
      :Trap 0
          z.Dispose
      :EndTrap
      :If 0≠en ⋄ em ⎕SIGNAL en ⋄ :EndIf
    ∇

    ∇ zipfile AddFile args;z;⎕USING;en;em;filename;entryname
      :Access public shared
      args←{2>|≡⍵:,⊂⍵ ⋄ ⍵}args
      (filename entryname)←2↑args,(⍴args)↓'' ''
      :If ''≡entryname ⋄ entryname←filename ⋄ :EndIf
      en←0 ⋄ em←''
      :Trap 0
          z←zipfile Open'U'
          {}ZipFileExtensions.CreateEntryFromFile(z filename entryname)
      :Else
          (en em)←⎕DMX.(EN EM) ⋄ :If em≡'EXCEPTION' ⋄ em←{⍵/⍨∧\~⍵∊⎕UCS 13 10}⍕⎕EXCEPTION ⋄ :EndIf
      :EndTrap
      :Trap 0
          z.Dispose
      :EndTrap
      :If 0≠en ⋄ em ⎕SIGNAL en ⋄ :EndIf
    ∇

:Endclass